---
title: FileSystemDirectoryHandle.getFileHandle()
slug: Web/API/FileSystemDirectoryHandle/getFileHandle
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemDirectoryHandle
  - Method
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>getFileHandle()</code></strong> method of the {{domxref("FileSystemDirectoryHandle")}} interface returns a {{domxref('FileSystemFileHandle')}} for a file with the specified name, within the directory the method is called.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>FileSystemFileHandle</var> = FileSystemDirectoryHandle.getFileHandle(name);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>name</em></dt>
 <dd>A {{domxref('USVString')}} representing the {{domxref('FileSystemHandle.name')}} of the file you wish to retrieve.</dd>
 <dt><em>options</em> {{optional_inline}}</dt>
 <dd>
 <ul>
  <li><code>create</code>: A {{jsxref('Boolean')}}. Default <code>false</code>. When set to <code>true</code> if the file is not found, one with the specified name will be created and returned.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} which resolves with a {{domxref('FileSystemFileHandle')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotAllowedError</code></dt>
 <dd>If {{domxref('PermissionStatus')}} is not 'granted'.</dd>
 <dt><code>TypeError</code></dt>
 <dd>If the name specified is not a valid string or contains characters that would interfere with the native file system</dd>
 <dt><code>TypeMismatchError</code></dt>
 <dd>If the named entry is a directory and not a file.</dd>
 <dt><code>NotFoundError</code></dt>
 <dd>if file doesn't exist and the <code>create</code> option is set to <code>false</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example returns a file handle with the specified name, if the file does not exist it is created.</p>

<pre class="brush: js notranslate">const fileName = 'fileToGetName';

// assuming we have a directory handle: 'currentDirHandle'
const fileHandle = currentDirHandle.getFileHandle(fileName, {create: true});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#api-filesystemdirectoryhandle-getfilehandle','getFileHandle')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryHandle.getFileHandle")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
